#! /bin/csh -f

if ( $#argv != 5 && $#argv != 9 && $#argv != 10 ) then
    echo "Usage : "$0" inlist outlist offsetlist y1 y2 [order1] [order2] [naverage1] [naverage2] [width to fit]"
    exit 1
endif

set infile=$1
set outfile=$2
set offfile=$3
set x1=$4
set x2=$5

set TMPFILE1=/tmp/lfit1d.tmp1
set TMPFILE2=/tmp/lfit1d.tmp2
set TMPIMG1=/tmp/tmp1.imh
set TMPIMG2=/tmp/tmp2.imh
set TMPIMG3=/tmp/tmp3.imh
set CLCOM=/tmp/cl.com

if( -f $CLCOM ) then
    rm -rf $CLCOM
endif

if ( $#argv == 5 ) then
    set ORDER1=3
    set ORDER2=15
    set NAVERAGE1=10
    set NAVERAGE2=5
    set CUTWIDTH=2048
else if ( $#argv == 9 ) then
    set ORDER1=$6
    set ORDER2=$7
    set NAVERAGE1=$8
    set NAVERAGE2=$9
    set CUTWIDTH=2048
else if ( $#argv == 10 ) then
    set ORDER1=$6
    set ORDER2=$7
    set NAVERAGE1=$8
    set NAVERAGE2=$9
    set CUTWIDTH=$10
endif

gawk -v x1=$x1 -v x2=$x2 -v cutwid=$CUTWIDTH 'BEGIN{xmin=1e10}{x[NR]=$2;if(x[NR]<xmin)xmin=x[NR];}END{for(i=1;i<=NR;i++)printf("%d %d %d %d %d\n",x1-(x[i]-xmin),x2-(x[i]-xmin),(x1+x2)/2-(x[i]-xmin)-cutwid/2,(x1+x2)/2-(x[i]-xmin)+cutwid/2,x[i]-xmin)}' $offfile > $TMPFILE1
paste $infile $outfile $TMPFILE1 > $TMPFILE2
    set i = 1
foreach filelist (`awk '{print($1)}' $TMPFILE2`)
set INFILE=`sed -n ${i}p $TMPFILE2 | gawk '{print($1)}'`
set OUTFILE=`sed -n ${i}p $TMPFILE2 | gawk '{print($2)}'`
set X1=`sed -n ${i}p $TMPFILE2 | gawk '{print($3-1)}'`
set X2=`sed -n ${i}p $TMPFILE2 | gawk '{print($4+1)}'`
set XMIN=`sed -n ${i}p $TMPFILE2 | gawk '{if(($5-1)>1)print($5-1);else print("1")}'`
set XMAX=`sed -n ${i}p $TMPFILE2 | gawk '{if(($6+1)<1025)print($6+1);else print("1024")}'`
echo $INFILE $OUTFILE $X1 $X2 $XMIN $XMAX
@ MX1 = $X1 + 1
@ MX2 = $X2 - 1
cat << EOF >> $CLCOM
	imdel $TMPIMG1,$TMPIMG2,$TMPIMG3
	fit1d $INFILE $TMPIMG1 axis=2 type=fit interac- sample="${XMIN}:${X1},${X2}:${XMAX}" functio=legendre order=$ORDER1 low_rej=2 high_rej=2 niterat=3 grow=3 naverage=$NAVERAGE1
	imcopy $INFILE $TMPIMG2
	imcopy $INFILE $TMPIMG3
	imcopy ${TMPIMG1}[*,${MX1}:${MX2}] ${TMPIMG2}[*,${MX1}:${MX2}] 
	boxcar $TMPIMG2 $TMPIMG2 $NAVERAGE1 1
	fit1d $TMPIMG2 $TMPIMG2 axis=2 type=fit interac- sample="${XMIN}:${XMAX}" functio=legendre order=$ORDER2 low_rej=2 high_rej=2 niterat=3 grow=1 naverage=$NAVERAGE2
	imdel $OUTFILE
	imarith $TMPIMG3 - $TMPIMG2 $OUTFILE
	disp $OUTFILE 1 fi+
EOF
@ i += 1
end

echo logout >> $CLCOM
cat $CLCOM | cl
