#include <stdio.h>
#include <string.h>
#include <math.h>

main(int argc,char *argv[])
{
 int n;
 double d,x,y,xo,yo,pixscale;

 if(argc < 2 || argc > 33){
   fprintf(stderr,"\nExample: %s NS_OPT SP4=10 AGO=0,-20 SP2=10 SP2=8\n",argv[0]);
   fprintf(stderr,"Corresponds to the following observation sequence\n\n");
   fprintf(stderr,"GETOBJECT ... OBE_MODE=SPEC_4 ... DITH=10\n");
   fprintf(stderr,"AGOFFSET ... DX=0 DY=-20\n");
   fprintf(stderr,"GETOBJECT ... OBE_MODE=SPEC_2 ... DITH=10\n");
   fprintf(stderr,"GETOBJECT ... OBE_MODE=SPEC_2 ... DITH=8\n\n");
   fprintf(stderr,"Maximum 32 inputs are available\n");
   exit(0);
 }

 if(strcmp(argv[1],"NS_OPT")==0) pixscale=0.111;
 else if(strcmp(argv[1],"NS_IR")==0) pixscale=0.105;
 else {
   fprintf(stderr,"M2-TYPE must be NS_OPT or NS_IR\n");
   exit(0);
 }
 n=2;xo=0.0;yo=0.0;
 while(n<argc){
   if(strncmp(argv[n],"IM2=",4)==0 || strncmp(argv[n],"SP2=",4)==0){
     if(strlen(argv[n]+4) != strspn(argv[n]+4,"0123456789-.")){
       fprintf(stderr,"Inputed value (%s) must be real number\n",argv[n]+4);
       exit(0);
     }
     sscanf(argv[n]+4,"%lf",&d);
     d/=pixscale;
     printf("%d  %d\n",(int)floor(xo+0.5),(int)floor(0.5*d+yo+0.5));
     printf("%d  %d\n",(int)floor(xo+0.5),(int)floor(-0.5*d+yo+0.5));
   }
   else if(strncmp(argv[n],"IM4=",4)==0){
     if(strlen(argv[n]+4) != strspn(argv[n]+4,"0123456789-.")){
       fprintf(stderr,"Inputed value (%s) must be real number\n",argv[n]+4);
       exit(0);
     }
     sscanf(argv[n]+4,"%lf",&d);
     d/=pixscale;
     printf("%d  %d\n",(int)floor(0.5*d+xo+0.5),(int)floor(0.5*d+yo+0.5));
     printf("%d  %d\n",(int)floor(0.5*d+xo+0.5),(int)floor(-0.5*d+yo+0.5));
     printf("%d  %d\n",(int)floor(-0.5*d+xo+0.5),(int)floor(-0.5*d+yo+0.5));
     printf("%d  %d\n",(int)floor(-0.5*d+xo+0.5),(int)floor(0.5*d+yo+0.5));
   }
   else if(strncmp(argv[n],"IM8=",4)==0){
     if(strlen(argv[n]+4) != strspn(argv[n]+4,"0123456789-.")){
       fprintf(stderr,"Inputed value (%s) must be real number\n",argv[n]+4);
       exit(0);
     }
     sscanf(argv[n]+4,"%lf",&d);
     d/=pixscale;
     printf("%d  %d\n",(int)floor(d/2+xo+0.5),(int)floor(-d/6+yo+0.5));
     printf("%d  %d\n",(int)floor(-d/2+xo+0.5),(int)floor(-d/6+yo+0.5));
     printf("%d  %d\n",(int)floor(d/6+xo+0.5),(int)floor(d/2+yo+0.5));
     printf("%d  %d\n",(int)floor(d/6+xo+0.5),(int)floor(-d/2+yo+0.5));
     printf("%d  %d\n",(int)floor(-d/2+xo+0.5),(int)floor(d/6+yo+0.5));
     printf("%d  %d\n",(int)floor(d/2+xo+0.5),(int)floor(d/6+yo+0.5));
     printf("%d  %d\n",(int)floor(-d/6+xo+0.5),(int)floor(-d/2+yo+0.5));
     printf("%d  %d\n",(int)floor(-d/6+xo+0.5),(int)floor(d/2+yo+0.5));
   }
   else if(strncmp(argv[n],"SP4=",4)==0){
     if(strlen(argv[n]+4) != strspn(argv[n]+4,"0123456789-.")){
       fprintf(stderr,"Inputed value (%s) must be real number\n",argv[n]+4);
       exit(0);
     }
     sscanf(argv[n]+4,"%lf",&d);
     d/=pixscale;
     printf("%d  %d\n",(int)floor(xo+0.5),(int)floor(0.6*d+yo+0.5));
     printf("%d  %d\n",(int)floor(xo+0.5),(int)floor(-0.4*d+yo+0.5));
     printf("%d  %d\n",(int)floor(xo+0.5),(int)floor(0.4*d+yo+0.5));
     printf("%d  %d\n",(int)floor(xo+0.5),(int)floor(-0.6*d+yo+0.5));
   }

   else if(strncmp(argv[n],"SPABBA=",7)==0){
     if(strlen(argv[n]+7) != strspn(argv[n]+7,"0123456789-.")){
       fprintf(stderr,"Inputed value (%s) must be real number\n",argv[n]+7);
       exit(0);
     }
     sscanf(argv[n]+7,"%lf",&d);
     d/=pixscale;
     printf("%d  %d\n",(int)floor(xo+0.5),(int)floor(0.5*d+yo+0.5));
     printf("%d  %d\n",(int)floor(xo+0.5),(int)floor(-0.5*d+yo+0.5));
     printf("%d  %d\n",(int)floor(xo+0.5),(int)floor(-0.5*d+yo+0.5));
     printf("%d  %d\n",(int)floor(xo+0.5),(int)floor(0.5*d+yo+0.5));
   }

   else if(strncmp(argv[n],"AGO=",4)==0){
     if(strlen(argv[n]+4) != strspn(argv[n]+4,"0123456789-.,")){
       fprintf(stderr,"Inputed value (%s) must be real number\n",argv[n]+4);
       exit(0);
     }
     sscanf(argv[n]+4,"%lf,%lf",&x,&y);
     xo-=x;yo-=y;
   }
   else {
     fprintf(stderr,"Argument (%s) must be IM2/IM4/IM8/SP2/SP4/SPABBA/AGO\n",argv[n]);
     exit(0);
   }
   n++;
 }
}
